#!/usr/bin/env zsh

###--------------------------------
### --- ATTENTION : script en zsh
###--------------------------------


#--------------------------------
# ce script necessite un argument :
#    1- executable herezh
#--------------------------------

#
# verif de la presence d un argument
#
if [ ! $1 ] ; then
  echo
  echo "**ERREUR : un argument requis (executable Herezh)"
  echo
  exit
fi

#
# verif de l existence de l executable donne en argument (avec which)
#
a=`which $1 | grep "not found"`
if [ $a ] ; then
  echo
  echo "**ERREUR (prog:$0) : la commande $cmd_herezh est introuvable"
  a=`which $1`
  echo "           Resultat de la commande  \"which $1\" => $a"
  echo
  exit
fi

#
# desormais, l executable donne en argument se trouve dans la variable $cmd_herezh
#
cmd_herezh=$1



#
# verif de la presence du repertoire Rapport
#   > si absent => creation
#   > si existe mais est un fichier => arret avec message d erreur
#
if [ -f ./Rapport ] ; then
  echo
  echo "**ERREUR (prog:$0) : la presence d un repertoire de nom Rapport est necessaire mais il existe deja un fichier de nom Rapport. Veuillez renommer ce fichier, le deplacer dans un autre repertoire ou le supprimer..."
  echo
  exit
elif [ ! -d ./Rapport ] ; then
  mkdir Rapport
fi





####################################
### PROGRAMME POUR TESTS RAPIDES ###
####################################

   ###--------------------------------------------###
   ###--- Changement du nom du fichier rapport ---###
   ###---    des derniers tests effectus      ---###
   ###--------------------------------------------###
mv -f Rapport/rapport_test_R.txt Rapport/rapport_test_R_OLD.txt

   ###---------------------------------------###
   ###--- Gnration d'un nouveau rapport ---###
   ###---------------------------------------###
./Perl/genere_rapport.pl Rapport/rapport_test.txt $cmd_herezh

   ###-------------------------------------------------------###
   ###--- Recherche de tous les rpertoires /Test_R*      ---###
   ###---    dans le rpertoire /Batterie                 ---###
   ###--- Cration du fichier Liste_Tests_R.txt contenant ---###
   ###---    le chemin de tous ces rpertoires /Test_R*   ---###
   ###-------------------------------------------------------###
mv Rapport/Liste_Tests_R.txt Rapport/Liste_Tests_R_OLD.txt
foreach f (`find . -name "Test_R*" -type d`)
  echo $f >> Rapport/Liste_Tests_R.txt
end

   ###------------------------------------###
   ###--- Execution de la vrification ---###
   ###---    pour les tests rapides    ---###
   ###------------------------------------###
      #-----------------------------------------------------#
      #- Recherche de tous les rpertoires /Test_R*        -#
      #-    dans le rpertoire /Batterie                   -#
      #- Execution de "test.pl nom_repertoire type_calcul" -# 
      #-    une fois que l'on est plac au bon endroit     -#
      #-----------------------------------------------------#
foreach  f (`find . -name "Test_R*" -type d`)
  ./Perl/test.pl $f $cmd_herezh
end

   ###--------------------------------------###
   ###--- Edition du fichier rapport.txt ---###
   ###--------------------------------------###
mv Rapport/rapport_test.txt Rapport/rapport_test_R.txt
nedit Rapport/rapport_test_R.txt &



##################################
### PROGRAMME POUR TESTS LONGS ###
##################################

   ###--------------------------------------------###
   ###--- Changement du nom du fichier rapport ---###
   ###---    des derniers tests effectus      ---###
   ###--------------------------------------------###
mv -f Rapport/rapport_test_L.txt Rapport/rapport_test_L_OLD.txt

   ###---------------------------------------###
   ###--- Gnration d'un nouveau rapport ---###
   ###---------------------------------------###
./Perl/genere_rapport.pl Rapport/rapport_test.txt $cmd_herezh

   ###-------------------------------------------------------###
   ###--- Recherche de tous les rpertoires /Test_L       ---###
   ###---    dans le rpertoire /Batterie                 ---###
   ###--- Cration du fichier Liste_Tests_L.txt contenant ---###
   ###---    le chemin de tous ces rpertoires /Test_L    ---###
   ###-------------------------------------------------------###
mv Rapport/Liste_Tests_L.txt Rapport/Liste_Tests_L_OLD.txt
foreach f (`find . -name "Test_L*" -type d`)
  echo $f >> Rapport/Liste_Tests_L.txt
end

   ###------------------------------------###
   ###--- Execution de la vrification ---###
   ###---    pour tous les tests longs ---###
   ###------------------------------------###
      #-----------------------------------------------------#
      #- Recherche de tous les rpertoires /Test*          -#
      #-    dans le rpertoire /Batterie                   -#
      #- Execution de "test.pl nom_repertoire type_calcul" -# 
      #-    une fois que l'on est plac au bon endroit     -#
      #-----------------------------------------------------#
foreach f (`find . -name "Test_L*" -type d`)
  ./Perl/test.pl $f $cmd_herezh
end

   ###--------------------------------------###
   ###--- Edition du fichier rapport.txt ---###
   ###--------------------------------------###
mv Rapport/rapport_test.txt Rapport/rapport_test_L.txt
nedit Rapport/rapport_test_L.txt &
